diff --git a/tailsgreeter/persistence.py b/tailsgreeter/persistence.py
index e1415fa..cabefd6 100644
--- a/tailsgreeter/persistence.py
+++ b/tailsgreeter/persistence.py
@@ -54,15 +54,17 @@ class PersistenceSettings(object):
         Returns: True if everything went fine, False if the user should try
         again."""
         logging.debug("Unlocking persistence")
-        try:
-            self.activate_container(
-                device=self.containers[0]['path'],
-                password=passphrase,
-                readonly=readonly)
-            self.is_unlocked = True
-            return True
-        except tailsgreeter.errors.WrongPassphraseError:
-            return False
+        for container in self.containers:
+            try:
+                self.activate_container(
+                    device=container['path'],
+                    password=passphrase,
+                    readonly=readonly)
+                self.is_unlocked = True
+                return True
+            except tailsgreeter.errors.WrongPassphraseError:
+                pass
+        return False

     def lock(self):
         logging.debug("Locking persistence")
@@ -133,7 +135,7 @@ class PersistenceSettings(object):
                 "/sbin/cryptsetup", "luksClose",
                 self.cleartext_name
                 ]
-            self.check_output_and_error(
+            tailsgreeter.utils.check_output_and_error(
                 args,
                 exception=tailsgreeter.errors.LivePersistError,
                 error_message=_("cryptsetup failed with return code "
